#*************************************************************
# Progamm 			fluisa_wlgl_stat_2d_quelle
# Sinn des Programms: 		Löser der Wärmeleitungsgl.
# Sinn der Einheit  :		Ausgabe
# Name der Datei    :		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_stat_2d_quelle_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	7
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			07.07.2022
# Letzte Änderung: 		08.09.2022
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os

import numpy as np
#*************************************************************
# Import der Klasse matplotlib.pyplot für die Graphikausgabe
#*************************************************************
import matplotlib.pyplot as plt


from mpl_toolkits.mplot3d import Axes3D

class Ausgabe:
  #Konstruktormethode
  def __init__(self):		
    print("Ausgabeobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Ausgabeobjekt entfernt")  

#*************************************************************
# Funktion zur Ausgabe in der Konsole
#*************************************************************
  def schirm_ausgabe(self,m,n,x,y,T):
    print("Schirmaugabe")

    for i in range(m):
      for j in range(n):
        print ("%5i" %i,"%5i" %j,"%6.5f" %x[i][j], "%6.5f" %y[i][j], "%6.5f" %T[i][j])


#*************************************************************
# Funktion zur Ausgabe in eine Datei
#*************************************************************
  def datei_ausgabe(self, ausgabe_datei, m, n, x, y, T):
    fobj_out = open(ausgabe_datei,"w")
    for i in range(m):
      for j in range(n):    
        fobj_out.write(str("%5i" %i))
        fobj_out.write("\t")
        fobj_out.write(str("%5i" %j))
        fobj_out.write("\t")      
        fobj_out.write(str("%6.5f" %x[i][j]))    
        fobj_out.write("\t")      
        fobj_out.write(str("%6.5f" %y[i][j]))           
        fobj_out.write("\t")
        fobj_out.write(str("%6.5f" %T[i][j])) 
        fobj_out.write("\n")
    fobj_out.close()


#*************************************************************
# Funktion zur graphischen Ausgabe
#*************************************************************
  def graphik_ausgabe_3d_T(self,m, n, x, y,T, graphik_datei_ausgabe_wähler,graphik_3d_datei_name, graphik_3d_datei_format, graphik_titel):
    x_min=0.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    for i in range(m):
      for j in range(n):
        if x_min >= x[i][j]:
          x_min = x[i][j]
        if x_max <= x[i][j]:
          x_max = x[i][j]
        if y_min >= y[i][j]:
          y_min = y[i][j]
        if y_max <= y[i][j]:
          y_max = y[i][j]
          
          
    fig = plt.figure(figsize=(5,5))

    ax = fig.add_subplot(111, projection='3d')
    ax.set_title(graphik_titel)
    ax.scatter(x,y,T) 
    ax.set_xlabel("x [m]")
    ax.set_ylabel("y [m]")
    ax.set_zlabel("T [K]")
    ax.view_init(30, 270) # Drehung um 270° zur besseren Sicht    
    if(graphik_datei_ausgabe_wähler):
        plt.savefig(graphik_3d_datei_name + '.' + graphik_3d_datei_format, format=graphik_3d_datei_format)  
      
    plt.show()
   
    
  def graphik_ausgabe_kontur_T(self,m, n, x, y,T, graphik_datei_ausgabe_wähler,graphik_kontur_datei_name, graphik_kontur_datei_format, graphik_titel):    
    x_min=0.0
    x_max=0.0
    y_min=0.0
    y_max=0.0
    for i in range(m):
      for j in range(n):
        if x_min >= x[i][j]:
          x_min = x[i][j]
        if x_max <= x[i][j]:
          x_max = x[i][j]
        if y_min >= y[i][j]:
          y_min = y[i][j]
        if y_max <= y[i][j]:
          y_max = y[i][j]
          
          
    a = np.linspace(x_min, x_max, m)
    b = np.linspace(y_min, y_max, n)

    X, Y = np.meshgrid(b,a)
    plt.title(graphik_titel)
    plt.xlabel('x [m]')
    plt.ylabel('y [m]')
    plt.contourf(Y, X, T, 20, cmap='RdBu_r');
    plt.colorbar();
    if(graphik_datei_ausgabe_wähler):
      plt.savefig(graphik_kontur_datei_name + '.' + graphik_kontur_datei_format, format=graphik_kontur_datei_format)     
    plt.show()


