#*************************************************************
# Progamm 			fluisa_wlgl_stat_2d_quelle
# Sinn des Programms: 		Löser der Wärmeleitungsgl.
# Sinn der Einheit  :		Einlesen des Gitters
# Name der Datei    :		gitter.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_stat_2d_quelle_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	3
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			20.10.2021
# Letzte Änderung: 		08.09.2022
#*************************************************************


#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os
#*************************************************************
# Import der Klasse pickle zum Auslesen von Binärdateien
#*************************************************************
import pickle


# import math
import numpy as np
#*************************************************************
# Klassendefinition Koeffizientenmatrix
#*************************************************************
class Gitter:
  #Konstruktormethode
  def __init__(self):		
    print("Gitterobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Gitterobjekt entfernt")   
    
    
#*************************************************************
# Funktion zum Einlesen des FVM-Gitters
#*************************************************************
  def gitter_input(self,gitter_datei, gitter_ascii_bin):
    self.rückgabeliste = list(range(2))
    self.rückgabeliste[0] = True                                   # Einlesen des Gitters korrekt            True/False
    self.rückgabeliste[1] = "Gitterdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen aus Gitterdatei  Text   
    print("Einlesen des Gitters")    
    print("Name der Gitter_datei:",gitter_datei)
#*************************************************************
# Öffnung der Gitterdatei
#*************************************************************
    if os.path.exists(gitter_datei):
      print("Datei ist vorhanden")
      if gitter_ascii_bin == "a":
        fobj_in = open(gitter_datei,"r") 
#*************************************************************
# Einlesen der Anzahl der Gitterpunkte m
#*************************************************************
        zeile=fobj_in.readline()
        self.index = self.bool_function(zeile[:-1])
        if self.index:
          leseindex = 2
        else:
          leseindex = 0  
        zeile=fobj_in.readline()
        self.puffer = zeile[:-1]
        gitter_typ = self.puffer
        print("Gittertyp=", gitter_typ)
        zeile=fobj_in.readline()
    # Hier Trennen    
        self.puffer = zeile[:-1]
        self.puffer = self.puffer.split("\t")
        self.m = int(self.puffer[0])
        self.n = int(self.puffer[1])
        # Felder 
        self.x =  np.zeros((self.m, self.n))
        self.y =  np.zeros((self.m, self.n)) 
        self.delta_x = np.zeros((self.m-1, self.n))
        self.delta_y = np.zeros((self.m, self.n-1))
        self.x_gf =  np.zeros((self.m-1, self.n-1))
        self.y_gf =  np.zeros((self.m-1, self.n-1))      
        self.A_gf_we = np.zeros((self.m-1, self.n-2)) # A_gf_we: Flächeninhalt der westlichen bzw. östlichen Grenzfläche - erstreckt in süd-nord-Richtung  
        self.A_gf_sn = np.zeros((self.m-2, self.n-1)) # A_gf_sn: Flächeninhalt der südlichen bzw. nördlichen Grenzfläche - erstreckt in west-ost-Richtung           
        self.Delta_x =np.zeros((self.m-1, self.n))
        self.Delta_y =np.zeros((self.m-1, self.n)) 
        self.V =np.zeros((self.m-1, self.n-1)) 
           
#*************************************************************
# Einlesen der Knoten x und y
#*************************************************************        
        for i in range(self.m):
          for j in range(self.n):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.x[i][j] = float(self.puffer[leseindex])
            self.y[i][j] = float(self.puffer[leseindex+1])

#*************************************************************
# Einlesen der Knotenabstände delta_x
#*************************************************************  
        for i in range(self.m-1):
          for j in range(self.n):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.delta_x[i][j] = float(self.puffer[leseindex])

#*************************************************************
# Einlesen der Knotenabstände delta_y
#*************************************************************              
        for i in range(self.m):
          for j in range(self.n-1):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.delta_y[i][j] = float(self.puffer[leseindex])
            
#*************************************************************
# Einlesen der Grenzflächenkoordinaten - Anfangs- und Endpunkte
#*************************************************************              
        for i in range(self.m-1):
          for j in range(self.n-1):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.x_gf[i][j] = float(self.puffer[leseindex])
            self.y_gf[i][j] = float(self.puffer[leseindex+1])
                                
          
#*************************************************************
# Einlesen der A_gf_we: Flächeninhalt der westlichen bzw. östlichen Grenzflächen
#*************************************************************              
        for i in range(self.m-1):
          for j in range(self.n-2):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.A_gf_we[i][j] = float(self.puffer[leseindex])
                                            
#*************************************************************
# Einlesen der A_gf_sn: Flächeninhalt der südlichen bzw. nördlichen Grenzflächen
#*************************************************************  
        for i in range(self.m-2):
          for j in range(self.n-1):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.A_gf_sn[i][j] = float(self.puffer[leseindex])
                                         

#*************************************************************
# Einlesen der Grenzflächenabstände in X-Richtung Delta_x
#*************************************************************  
        for i in range(self.m-2):
          for j in range(self.n-1):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.Delta_x[i][j] = float(self.puffer[leseindex])
            
#*************************************************************
# Einlesen der Grenzflächenabstände in Y-Richtung Delta_y
#*************************************************************              
        for i in range(self.m-1):
          for j in range(self.n-2):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.Delta_y[i][j] = float(self.puffer[leseindex])            

        
#*************************************************************
# Einlesen der Volumina der FV V[i][j]
#*************************************************************
        for i in range(self.m-2):
          for j in range(self.n-2):
            zeile=fobj_in.readline()  
            zeile[:-1]
            self.puffer = zeile.split("\t")
            self.V[i][j] = float(self.puffer[leseindex])    
                    
        fobj_in.close()

      elif gitter_ascii_bin == "b":
        fobj_in = open(gitter_datei,"rb")
        gitter_typ = pickle.load(fobj_in)
        if gitter_typ == "v":        
          self.m = pickle.load(fobj_in)
          self.n = pickle.load(fobj_in)
          self.x = pickle.load(fobj_in)
          self.y = pickle.load(fobj_in)
          self.delta_x = pickle.load(fobj_in)
          self.delta_y = pickle.load(fobj_in)        
          x_gf = pickle.load(fobj_in)
          y_gf = pickle.load(fobj_in) 
          self.A_gf_we = pickle.load(fobj_in)               
          self.A_gf_sn = pickle.load(fobj_in)
          self.Delta_x = pickle.load(fobj_in)
          self.Delta_y = pickle.load(fobj_in)        
          self.V = pickle.load(fobj_in) 
          fobj_in.close()
        elif gitter_typ == "d":
          print("Falscher Gittertyp, es wird ein Finite-Volumen-Gitter gebraucht") 
          self.rückgabeliste[0] = False        
      else:
        print("Gitter weder ASCII noch binär")
        self.rückgabeliste[0] = False   
 
    else:
      print("Datei ist NICHT vorhanden")
      self.rückgabeliste[0] = False                                   # Einlesen des Gitters korrekt            True/False
      self.rückgabeliste[1] = "Gitterdatei nicht vorhanden!" 
    print(self.rückgabeliste[0]) 
    return self.rückgabeliste[0]

#*************************************************************
# Funktion zum Definieren von bool-Variablen
#*************************************************************
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return False

    
