#*************************************************************
# Progamm 			fluisa_wlgl_stat_2d_quelle
# Sinn des Programms: 		Löser der Wärmeleitungsgl.
# Sinn der Einheit  :		Aufstellung der Koeffizientenmatrix
# Name der Datei    :		koeff_matrix.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_stat_2d_quelle_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			23.02.2022
# Letzte Änderung: 		31.12.2022
#*************************************************************

#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os
import pickle


import math
import numpy as np
#*************************************************************
# Klassendefinition Koeffizientenmatrix
#*************************************************************
class Koeff_matrix:
  #Konstruktormethode
  def __init__(self):		
    print("Koeff_matrixobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Koeff_matrixobjekt entfernt")          




#*************************************************************
# Funktion zum Aufstellen der Koeffizientenmatrix
#*************************************************************

  def matrix(self, lambada, c, rho,s_init,  m, n, delta_x, delta_y, A_gf_we, A_gf_sn,V,rand_art_west,rand_art_ost,rand_art_süd,rand_art_nord, \
  rand_wert_west,rand_wert_ost,rand_wert_süd,rand_wert_nord): 
    self.rückgabeliste = list(range(2))
    self.rückgabeliste[0] = True                                   # Erstellen der Koeffizientenmatrix korrekt   True/False
    self.rückgabeliste[1] = "Koeffizientenmatrix wurde erstellt"   # Fehlermeldung für Einlesen aus Gitterdatei  Text  
    try:
      print("Besetzung der Koeffizientenmatrix")
#*************************************************************
# Leider sieht Python für die Buchstabenfolge "lambda"
# etwas anderes vor. "lambda" ist aber das Kürzel für 
# die Wärmeleitfähigkeit.
# Wir fanden einen naheliegenden Ersatz: 
#*************************************************************
    
      a = lambada/c/rho
#*************************************************************
# Hier: a konst für alle FV
#*************************************************************

      self.a_p = np.zeros((m,n))
      self.a_w = np.zeros((m,n))
      self.a_e = np.zeros((m,n))
      self.a_s = np.zeros((m,n)) # as ist ein Schlüsselwort in Python, daher a_s
      self.a_n = np.zeros((m,n))    
      self.rtk = np.zeros((m,n))
      self.rtp = np.zeros((m,n))
      self.s = np.zeros((m,n))
      print("s_init = ", s_init)
    #innere Punkte
      for i in range(1,m-1):
        for j in range(1,n-1):
          self.a_w[i][j] = A_gf_we[i-1][j-1]*a/delta_x[i-1][j] 
          self.a_e[i][j] = A_gf_we[i][j-1]*a/delta_x[i][j] 
          self.a_s[i][j] = A_gf_sn[i-1][j-1]*a/delta_y[i][j-1] 
          self.a_n[i][j] = A_gf_sn[i-1][j]*a/delta_y[i][j] 
          self.rtk[i][j] = 0.0
          self.rtp[i][j] = 0.0
          self.a_p[i][j] = -(self.a_w[i][j]+self.a_e[i][j]+self.a_s[i][j]+self.a_n[i][j]+self.rtp[i][j])
          self.s[i][j] = -s_init/c*V[i-1][j-1] + self.rtk[i][j]

    # Westrand 
      for j in range(1,n-1):    
        if rand_art_west[j] == "d":
          T_A = rand_wert_west[j]
          self.a_w[0][j]=0.0
          self.a_e[0][j]=0.0
          self.a_s[0][j]=0.0
          self.a_n[0][j]=0.0        
          self.rtk[0][j]=T_A
          self.rtp[0][j]=-1.0     
          self.a_p[0][j] = -(self.a_w[0][j]+self.a_e[0][j]+self.a_s[0][j]+self.a_n[0][j]+self.rtp[0][j])
          self.s[0][j] = 0.0 + self.rtk[0][j]
        elif rand_art_west[j] == "n":
          q_punkt_A = rand_wert_west[j]
          self.a_w[0][j]=0.0
          self.a_e[0][j]=-lambada/delta_x[0][j] # oder i = 1
          self.a_s[0][j]=0.0
          self.a_n[0][j]=0.0          
          self.rtk[0][j]=q_punkt_A 
          self.rtp[0][j]=0.0;              
          self.a_p[0][j] = -(self.a_w[0][j]+self.a_e[0][j]+self.a_s[0][j]+self.a_n[0][j]+self.rtp[0][j])  
          self.s[0][j] = 0.0 + self.rtk[0][j]
        else:
          pass      
            
    # Ostrand
      for j in range(1,n-1):    
        if rand_art_ost[j] == "d":
          T_B = rand_wert_ost[j]
          self.a_w[m-1][j]=0.0
          self.a_e[m-1][j]=0.0
          self.a_s[m-1][j]=0.0
          self.a_n[m-1][j]=0.0        
          self.rtk[m-1][j]=T_B
          self.rtp[m-1][j]=-1.0    
          self.a_p[m-1][j] = -(self.a_w[m-1][j]+self.a_e[m-1][j]+self.a_s[m-1][j]+self.a_n[m-1][j]+self.rtp[m-1][j])  
          self.s[m-1][j] = 0.0 + self.rtk[m-1][j]
        elif rand_art_ost[j] == "n":
          q_punkt_B = rand_wert_ost[j]
          self.a_w[m-1][j]=lambada/delta_x[m-2][j] # m-1 ??
          self.a_e[m-1][j]=0.0
          self.a_s[m-1][j]=0.0
          self.a_n[m-1][j]=0.0          
          self.rtk[m-1][j]=q_punkt_B 
          self.rtp[m-1][j]=0.0;              
          self.a_p[m-1][j] = -(self.a_w[m-1][j]+self.a_e[m-1][j]+self.a_s[m-1][j]+self.a_n[m-1][j]+self.rtp[m-1][j])  
          self.s[m-1][j] = 0.0 + self.rtk[m-1][j]
        else:
          pass           
    
    #Südrand
      for i in range(1,m-1):    
        if rand_art_süd[i] == "d":
          T_C = rand_wert_süd[i] 
          self.a_w[i][0]=0.0
          self.a_e[i][0]=0.0
          self.a_s[i][0]=0.0
          self.a_n[i][0]=0.0        
          self.rtk[i][0]=T_C
          self.rtp[i][0]=-1.0    
          self.a_p[i][0] = -(self.a_w[i][0]+self.a_e[i][0]+self.a_s[i][0]+self.a_n[i][0]+self.rtp[i][0])
          self.s[i][0] = 0.0 + self.rtk[i][0]
        elif rand_art_süd[i] == "n":
          q_punkt_C = rand_wert_süd[i]
          self.a_w[i][0]=0.0
          self.a_e[i][0]=0.0
          self.a_s[i][0]=0.0
          self.a_n[i][0]=-lambada/delta_y[i][0] # oder i = 1          
          self.rtk[i][0]=q_punkt_C 
          self.rtp[i][0]=0.0;              
          self.a_p[i][0] = -(self.a_w[i][0]+self.a_e[i][0]+self.a_s[i][0]+self.a_n[i][0]+self.rtp[i][0])  
          self.s[i][0] = 0.0 + self.rtk[i][0]        
        else:
          pass  
        
    # Nordrand
      for i in range(1,m-1):    
        if rand_art_nord[i] == "d":
          T_D = rand_wert_nord[i] #j
          self.a_w[i][n-1]=0.0
          self.a_e[i][n-1]=0.0
          self.a_s[i][n-1]=0.0
          self.a_n[i][n-1]=0.0        
          self.rtk[i][n-1]=T_D
          self.rtp[i][n-1]=-1.0      
          self.a_p[i][n-1] = -(self.a_w[i][n-1]+self.a_e[i][n-1]+self.a_s[i][n-1]+self.a_n[i][n-1]+self.rtp[i][n-1])  
          self.s[i][n-1] = 0.0 + self.rtk[i][n-1]        
        elif rand_art_nord[i] == "n":
          q_punkt_D = rand_wert_nord[i]
          self.a_w[i][n-1]=0.0
          self.a_e[i][n-1]=0.0
          self.a_s[i][n-1]=lambada/delta_y[i][n-2] # m-1 ??
          self.a_n[i][n-1]=0.0          
          self.rtk[i][n-1]=q_punkt_D 
          self.rtp[i][n-1]=0.0;              
          self.a_p[i][n-1] = -(self.a_w[i][n-1]+self.a_e[i][n-1]+self.a_s[i][n-1]+self.a_n[i][n-1]+self.rtp[i][n-1]) 
          self.s[i][n-1] = 0.0 + self.rtk[i][n-1] 
        else:
          pass                     
    
    # Süd-West_Ecke
    # Dirichlet-Dirichlet
      if rand_art_west[0] == "d" and rand_art_süd[0] == "d":
        T_A = rand_wert_west[0]
        T_C = rand_wert_süd[0]
        self.a_w[0][0]=0.0
        self.a_e[0][0]=0.0
        self.a_s[0][0]=0.0
        self.a_n[0][0]=0.0        
        self.rtk[0][0]=(T_A + T_C)/2.0
        self.rtp[0][0]=-1.0     
        self.a_p[0][0] = -(self.a_w[0][0]+self.a_e[0][0]+self.a_s[0][0]+self.a_n[0][0]+self.rtp[0][0])  
        self.s[0][0] = 0.0  + self.rtk[0][0]
    #sonst         
      else:
        self.a_w[0][0]=0.0
        self.a_e[0][0]=0.5 
        self.a_s[0][0]=0.0
        self.a_n[0][0]=0.5   
        self.rtk[0][0]=0.0
        self.rtp[0][0]=0.0   
        self.a_p[0][0] = -(self.a_w[0][0]+self.a_e[0][0]+self.a_s[0][0]+self.a_n[0][0]+self.rtp[0][0])   
        self.s[0][0] = 0.0          
    
    # Nord-West_Ecke
    # Dirichlet-Dirichlet
      if rand_art_west[n-1] == "d" and rand_art_nord[0] == "d":
        T_A = rand_wert_west[n-1]
        T_D = rand_wert_nord[0]
        self.a_w[0][n-1]=0.0
        self.a_e[0][n-1]=0.0
        self.a_s[0][n-1]=0.0
        self.a_n[0][n-1]=0.0        
        self.rtk[0][n-1]=(T_A + T_D)/2.0
        self.rtp[0][n-1]=-1.0     
        self.a_p[0][n-1] = -(self.a_w[0][n-1]+self.a_e[0][n-1]+self.a_s[0][n-1]+self.a_n[0][n-1]+self.rtp[0][n-1]) 
        self.s[0][n-1] = 0.0 + self.rtk[0][n-1]
    #sonst        
      else:
        self.a_w[0][n-1]=0.0
        self.a_e[0][n-1]=0.5 
        self.a_s[0][n-1]=0.5 
        self.a_n[0][n-1]=0.0       
        self.rtk[0][n-1]=0.0
        self.rtp[0][n-1]=0.0     
        self.a_p[0][n-1] = -(self.a_w[0][n-1]+self.a_e[0][n-1]+self.a_s[0][n-1]+self.a_n[0][n-1]+self.rtp[0][n-1])       
        self.s[0][n-1] = 0.0            
    
    # Süd-Ost_Ecke
# Dirichlet-Dirichlet
      if rand_art_ost[0] == "d" and rand_art_süd[m-1] == "d":
        T_B = rand_wert_ost[0]
        T_C = rand_wert_süd[m-1]
        self.a_w[m-1][0]=0.0
        self.a_e[m-1][0]=0.0
        self.a_s[m-1][0]=0.0
        self.a_n[m-1][0]=0.0        
        self.rtk[m-1][0]=(T_B + T_C)/2.0
        self.rtp[m-1][0]=-1.0     
        self.a_p[m-1][0] = -(self.a_w[m-1][0]+self.a_e[m-1][0]+self.a_s[m-1][0]+self.a_n[m-1][0]+self.rtp[m-1][0])    
        self.s[m-1][0] = 0.0 + self.rtk[m-1][0]     
# sonst        
      else:
        self.a_w[m-1][0]=0.5
        self.a_e[m-1][0]=0.0
        self.a_s[m-1][0]=0.0
        self.a_n[m-1][0]=0.5    
        self.rtk[m-1][0]=0.0
        self.rtp[m-1][0]=0.0 # -1.0  
        self.a_p[m-1][0] = -(self.a_w[m-1][0]+self.a_e[m-1][0]+self.a_s[m-1][0]+self.a_n[m-1][0]+self.rtp[m-1][0])          
        self.s[m-1][0] = 0.0      
    # Nord-Ost_Ecke
# Dirichlet-Dirichlet
      if rand_art_ost[n-1] == "d" and rand_art_nord[m-1] == "d":
        T_B = rand_wert_ost[n-1]
        T_D = rand_wert_nord[m-1]
        self.a_w[m-1][n-1]=0.0
        self.a_e[m-1][n-1]=0.0
        self.a_s[m-1][n-1]=0.0
        self.a_n[m-1][n-1]=0.0        
        self.rtk[m-1][n-1]=(T_B + T_D)/2.0
        self.rtp[m-1][n-1]=-1.0      
        self.a_p[m-1][n-1] = -(self.a_w[m-1][n-1]+self.a_e[m-1][n-1]+self.a_s[m-1][n-1]+self.a_n[m-1][n-1]+self.rtp[m-1][n-1])
        self.s[m-1][n-1] = 0.0 + self.rtk[m-1][n-1]       
# sonst        
      else:
        self.a_w[m-1][n-1]=0.5
        self.a_e[m-1][n-1]=0.0
        self.a_s[m-1][n-1]=0.5
        self.a_n[m-1][n-1]=0.0
        self.rtk[m-1][n-1]=0.0
        self.rtp[m-1][n-1]=0.0 
        self.a_p[m-1][n-1] = -(self.a_w[m-1][n-1]+self.a_e[m-1][n-1]+self.a_s[m-1][n-1]+self.a_n[m-1][n-1]+self.rtp[m-1][n-1])  
        self.s[m-1][n-1] = 0.0        

    except:
      self.rückgabeliste[0] = False                                  
      self.rückgabeliste[1] = "Fehler beim Erstellen der Koeffizientenmatrix."        
    return self.rückgabeliste[0]          

