#*************************************************************
# Progamm:			fluisa_wlgl_stat_2d_quelle
# Sinn des Programms: 		Löser der Wärmeleitungsgleichung
# Sinn der Einheit  :		Löser des GlS
# Name der Datei    :		loeser_lgs_5diag.py
# Versionsnummer:		1
# Name dieser Datei:		fluisa_wlgl_stat_2d_quelle_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	6
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			28.08.2019
# Letzte Änderung: 		31.12.2022
#*************************************************************


import math
import numpy as np

class Löser_lgs_5diag:
  #Konstruktormethode
  def __init__(self):		
    print("Löserobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Löserobjekt entfernt")  

#*************************************************************
# Deklarieren und Initialisieren der Felder im Löser
# eine derartige Trennung verhindert bei instationären Problemen,
# daß in einer Zeitschleife die Felder wiederholt deklariert und initialisiert werden.
#*************************************************************    
  def feld_init(self,m,n):
    self.rückgabeliste_feld_init = list(range(3))
    self.rückgabeliste_feld_init[0] = True                                     # Errechnen einer Lösung korrekt              True/False
    self.rückgabeliste_feld_init[1] = "Initialisierung des Phi-Feldes o.k."    # Fehlermeldung für Einlesen aus Gitterdatei  Text 
    try:
      self.phi = np.zeros((m,n))
    except:
      self.rückgabeliste_feld_init[0] = False                                     # Errechnen einer Lösung korrekt              True/False
      self.rückgabeliste_feld_init[1] = "Fehler bei Initialisierung des Phi-Feldes"
    return self.rückgabeliste_feld_init[0] 
      					                #as, aw, ap, ae, an, s
  def gs_5diag(self,m,n, max_iter, eps, omega, resi_max, a, b, c, d,e,f, phi_init):
    self.rückgabeliste = list(range(3))
    self.rückgabeliste[0] = True                        # Errechnen einer Lösung korrekt              True/False
    self.rückgabeliste[1] = "Lösung wurde errechnet"    # Fehlermeldung für Einlesen aus Gitterdatei  Text  
    try:
      phi_speicher_relax = 0.0
      resi = 0.0 
      iter = 0
      ###resi_speicher = 0.0

      for i in range(m):
        for j in range(n):
          self.phi[i][j] = phi_init
   
      while(iter <= max_iter):
        resi_speicher = 0.0   
        for i in range(m):
          for j in range(n):
            phi_speicher_relax = self.phi[i][j]        
#Ecken
# Süd-West-Ecke    
            if i == 0 and j == 0:
              self.phi[0][0] = (f[0][0]-(d[0][0]*self.phi[1][0] + e[0][0]*self.phi[0][1]))/c[0][0]  
            elif i == 0 and j == n-1:
# Nord-West-Ecke
              self.phi[0][n-1] = (f[0][n-1]-(a[0][n-1]*self.phi[0][n-2]+d[0][n-1]*self.phi[1][n-1]))/c[0][n-1]  
# Süd-Ost-Ecke
            elif i == m-1 and j == 0:
              self.phi[m-1][0] = (f[m-1][0]-(b[m-1][0]*self.phi[m-2][0] + e[m-1][0]*self.phi[m-1][1]))/c[m-1][0]            
# Nord-Ost-Ecke
            elif i == m-1 and j == n-1:
              self.phi[m-1][n-1] = (f[m-1][n-1]-(a[m-1][n-1]*self.phi[m-1][n-2]+b[m-1][n-1]*self.phi[m-2][n-1]))/c[m-1][n-1]  
#Ränder            
# Westrand ohne Ecken
            elif i == 0 and j != 0 and j != n-1: 
              self.phi[0][j]= (f[0][j]-(a[0][j]*self.phi[0][j-1]+d[0][j]*self.phi[1][j]+e[0][j]*self.phi[0][j+1]))/c[0][j]             
# Südrand ohne Ecken
            elif j == 0 and i != 0 and i != m-1:
              self.phi[i][0]= (f[i][0]-(b[i][j]*self.phi[i-1][0]+d[i][0]*self.phi[i+1][j]+e[i][0]*self.phi[i][1]))/c[i][0]              
# Nordrand ohne Ecken
            elif j == n-1 and i != 0 and i != m-1:    
              self.phi[i][n-1]= (f[i][n-1]-(a[i][n-1]*self.phi[i][n-2]+b[i][j]*self.phi[i-1][n-1]+d[i][n-1]*self.phi[i+1][j]))/c[i][n-1]   
# Ostrand ohne Ecken
            elif i == m-1 and j != 0 and j != n-1: 
              self.phi[m-1][j]= (f[m-1][j]-(a[m-1][j]*self.phi[m-1][j-1]+b[m-1][j]*self.phi[m-2][j]+e[m-1][j]*self.phi[m-1][j+1]))/c[m-1][j]                      
            #print ("i=",i,"j=",j)                                 
# Innere Punkte
            elif 0 < i and i < m-1 and 0 < j and j < n-1: #m-1 und n-1 gehen nicht, es geht aber m-2,n-1 oder m-1, n-2       
              self.phi[i][j]= (f[i][j]-(a[i][j]*self.phi[i][j-1]+b[i][j]*self.phi[i-1][j]+d[i][j]*self.phi[i+1][j]+e[i][j]*self.phi[i][j+1]))/c[i][j] 

            self.phi[i][j] = self.phi[i][j]*omega+phi_speicher_relax*(1.0-omega)
            resi=math.sqrt((self.phi[i][j]-phi_speicher_relax)*(self.phi[i][j]-phi_speicher_relax)) 
  
            if (resi > resi_speicher):
              resi_speicher = resi      
                                             
        resi_max = resi_speicher 
        if resi_max <= eps:
          break   	
        iter+=1
        
      if iter >= max_iter:
        self.rückgabeliste[0] = False                        # Errechnen einer Lösung korrekt              True/False
        self.rückgabeliste[1] = "Löser konvergierte nicht"  
      self.rückgabeliste[2] = iter
    except:
      self.rückgabeliste[0] = False                        # Errechnen einer Lösung korrekt              True/False
      self.rückgabeliste[1] = "Lösung wurde nicht errechnet"    # Fehlermeldung für Einlesen aus Gitterdatei  Text     
    
    return self.rückgabeliste[0]
