#*************************************************************
# Progamm:			fluisa_wlgl_stat_2d_quelle
# Sinn des Programms: 		Löser der Wärmeleitungsgleichung
# Sinn der Einheit  :		Einlesen der Steuerdaten aus der Steuerdatei	
# Name dieser Datei:		steuer.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_stat_2d_quelle_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	2
# von:				7			
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.07.2018
# Letzte Änderung: 		03.01.2023
#*************************************************************

#*************************************************************
# Importieren der Klassen für Dateiauslesung
#*************************************************************
import os


class Steuer:
  #Konstruktormethode
  def __init__(self):		
    print("Steuerobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Steuerobjekt entfernt")  

#*************************************************************
# Abschalten der GUI-Funktionen nach Gebrauch
#*************************************************************     
  def ändern(self):
    self.eingabe_gui.destroy()   
    print(self.eingabe_neu())
        
  def ende(self):
    self.eingabe_gui.destroy()     
    
  def ende_neu(self):
    self.eingabe_gui_neu.destroy()  

#*************************************************************
# Funktion zum Öffnen der Steuerdatei und zum Auslesen der
# Steuerdaten
#*************************************************************
  def steuer_input(self):
    self.rückgabeliste = list(range(5))
    self.rückgabeliste[0] = True                                   # Einlesen von Steuerdatei korrekt            True/False
    self.rückgabeliste[1] = "Steuerdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen aus Steuerdatei  Text
    self.rückgabeliste[2] = False                                  # Manuelle Änderung                           True/False
    self.rückgabeliste[3] = True                                   # Manuelle Änderung korrekt                   True/False
    self.rückgabeliste[4] = "Keine Fehler in der Änderung"         # Fehlermeldung für manuelle Änderung         Text  
#*************************************************************
# Überprüfung ob die Steuerdatei existiert 
#*************************************************************
    if os.path.exists("steuer.txt"):
      print("Steuerdatei ist vorhanden")

#*************************************************************
# Importieren der Klassen zur graphischen Darstellung 
#*************************************************************    
      import tkinter
      self.eingabe_gui = tkinter.Tk()  
      print("Eingabedaten werden eingelesen")
      self.zeilen_zähler = 0
      fobj_in = open("steuer.txt","r")       
      for line in fobj_in:
        self.zeilen_zähler+=1
      fobj_in.close()  
      
      self.anzeige_liste = list(range(self.zeilen_zähler)) 
      self.zeilen_zähler = 0
#*************************************************************
# Öffnen der Steuerdatei
#*************************************************************
      fobj_in = open("steuer.txt","r") 
#*************************************************************
# Einlesen der Steuerdaten zeilenweise
#*************************************************************
      
      for zeile in fobj_in:
        self.anzeige_liste[self.zeilen_zähler] = zeile[:-1]
        if self.zeilen_zähler == 1:
        # Konstrukt wird gebraucht, um das Zeilenumbruchzeichen \n zu löschen 
          self.gitter_datei = zeile[:-1]
        if self.zeilen_zähler == 3:
          self.gitter_ascii_bin = zeile[:-1]
          if self.gitter_ascii_bin == "a" or self.gitter_ascii_bin == "b":
            pass
          else:
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen gitter_ascii_bin muß a oder b sein!\nProgramm bricht ab!"     
                      
        if self.zeilen_zähler == 5:
          self.rand_datei = zeile[:-1]
        if self.zeilen_zähler == 7:
          try:
            self.lambada = float(zeile[:-1])
            if self.lambada > 0.0:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen lambda muß > 0.0 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen lambda ist keine Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 9:
          try:
            self.c = float(zeile[:-1])
            if self.c > 0.0:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen c muß > 0.0 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen c ist keine Zahl!\nProgramm bricht ab!"
            
        if self.zeilen_zähler == 11:
          try:
            self.rho = float(zeile[:-1])
            if self.rho > 0.0:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen rho muß > 0.0 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen rho ist keine Zahl!\nProgramm bricht ab!"

        if self.zeilen_zähler == 13:
          try:
            self.s_init = float(zeile[:-1])
          except:  
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen s_init ist keine Zahl!\nProgramm bricht ab!"   

        if self.zeilen_zähler == 15:
          try:
            self.T_init = float(zeile[:-1])
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen T_init ist keine Zahl!\nProgramm bricht ab!"
          
        if self.zeilen_zähler == 17:
          try:
            self.eps = float(zeile[:-1])
            if self.eps > 0.0:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen epsilon muß > 0.0 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen epsilon ist keine Zahl!\nProgramm bricht ab!"          
          
        if self.zeilen_zähler == 19:
          try:
            self.max_iter = int(zeile[:-1])
            if self.max_iter > 100:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen max_iter muß > 100 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen max_iter ist keine ganze Zahl!\nProgramm bricht ab!"          
          
        if self.zeilen_zähler == 21:
          try:
            self.omega = float(zeile[:-1])
            if 0.0 < self.omega and self.omega < 1.96:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen omega muß > 0.0 und < 1.96 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen omega ist keine Zahl!\nProgramm bricht ab!" 
          
        if self.zeilen_zähler == 23:
          try:
            self.resi_max = float(zeile[:-1])
            if self.resi_max > 0.0:
              pass
            else:
              self.rückgabeliste[0] = False 
              self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen resi_max muß > 0.0 sein!\nProgramm bricht ab!"  
          except: 
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen resi_max ist keine Zahl!\nProgramm bricht ab!"           
          
        if self.zeilen_zähler == 25:
          self.schirm_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 27:        
          self.datei_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 29:
          self.ausgabe_datei = zeile[:-1]          
        if self.zeilen_zähler == 31:
          self.index_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 33:
          self.ausgabe_ascii_bin = zeile[:-1]
          if self.ausgabe_ascii_bin == "a" or self.ausgabe_ascii_bin == "b":
            pass
          else:
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Wert der Variablen ausgabe_ascii_bin muß a oder b sein!\nProgramm bricht ab!"       
                          
        if self.zeilen_zähler == 35:
          self.graphik_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 37:
          self.graphik_datei_ausgabe_wähler = self.bool_function(zeile[:-1])
        if self.zeilen_zähler == 39:
          self.graphik_3d_datei_name = zeile[:-1]  
        if(self.zeilen_zähler == 41):
          self.graphik_3d_datei_format = zeile[:-1]   
          self.graphik_formate_zulässig = set(['eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'])
          if self.graphik_3d_datei_format in self.graphik_formate_zulässig:
            pass
          else:
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!"            
        if self.zeilen_zähler == 43:
          self.graphik_kontur_datei_name = zeile[:-1]  
        if(self.zeilen_zähler == 45):
          self.graphik_kontur_datei_format = zeile[:-1]                            
          self.graphik_formate_zulässig = set(['eps', 'pdf', 'pgf','png', 'ps', 'raw', 'rgba', 'svg',  'svgz'])
          if self.graphik_kontur_datei_format in self.graphik_formate_zulässig:
            pass
          else:
            self.rückgabeliste[0] = False 
            self.rückgabeliste[1] = "Fehler in Steuerdatei: Python unterstützt das Graphikformat nicht!\nProgramm bricht ab!"          
          
        if self.zeilen_zähler == 47:
          self.graphik_titel = zeile[:-1]     
        self.zeilen_zähler += 1    
      fobj_in.close()

#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
#*************************************************************   
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui, text = self.anzeige_liste[i])
        
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
          #lb["font"] = "Arial 6 bold"
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten und 
# zum Start der Berechnungen
#*************************************************************
      weiter_button = tkinter.Button(self.eingabe_gui, text = "weiter", command = self.ende)
      weiter_button.grid(row=int(i/2+1), column=0, padx='1', pady='1', sticky='ew')
      ändern_button = tkinter.Button(self.eingabe_gui, text = "Eingabe ändern", command = self.ändern)
      ändern_button.grid(row=int(i/2+1), column=1, padx='1', pady='1', sticky='ew')
      #Endlosschleife
      self.eingabe_gui.mainloop()
    
    else:
      self.rückgabeliste[0] = False
      self.rückgabeliste[1] = "Steuerdatei ist nicht vorhanden" 
      
    return self.rückgabeliste[0]  
    
    
  def übernahme(self): 
    dummy = self.änderungs_feld_gitter_datei.get()
#*************************************************************
# Test ob in das Feld etwas eingeschrieben wurde
# wenn nicht, dann dummy != "" False
#*************************************************************    
    if dummy != "" and dummy != self.gitter_datei:           
      self.gitter_datei = dummy
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("gitter_datei geändert:", self.gitter_datei) 
    else:
      print("Keine Änderung der Variablengitter_datei")

    dummy = self.änderungs_feld_gitter_ascii_bin.get()
    if dummy != "" and dummy != self.gitter_ascii_bin:  
      if dummy == "a" or dummy == "b":
        self.gitter_ascii_bin = dummy
        self.rückgabeliste[2] = True
        self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
        print("self.gitter_ascii_bin geändert:", self.gitter_ascii_bin) 
      else:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen gitter_ascii_bin muß a oder b sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"            
    else:
      print("Keine Änderung der Variablen")  
      
    dummy = self.änderungs_feld_rand_datei.get()
    if dummy != "" and dummy != self.rand_datei:   
      self.rand_datei = dummy
      print("rand_datei geändert:",  self.rand_datei)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten."  
    else:
      print("Keine Änderung der Variablen rand_datei") 
      
    dummy = self.änderungs_feld_lambada.get()
    if dummy != "" and dummy != str(self.lambada): 
#*************************************************************
# Test ob in das Feld eingeschriebene(s) Zeichen eine Zahl ist/sind
# d.h. zu float konvertierbar ist
#*************************************************************          
      try:
        if float(dummy) > 0.0:
          self.lambada = float(dummy)
          self.rückgabeliste[2] = True
          self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
          print("lambda geändert:",  self.lambada)
        else:
          self.rückgabeliste[3] = False
          self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen lambda muß > 0.0 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"        
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen lambda ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen lambda")           
     
    dummy = self.änderungs_feld_c.get()
    if dummy != "" and dummy != str(self.c):  
      try:
        if float(dummy) > 0.0:
          self.c = float(dummy)
          self.rückgabeliste[2] = True
          self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
          print("c geändert:",  self.c) 
        else:
          self.rückgabeliste[3] = False
          self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen c muß > 0.0 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"        
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen c ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen c")           

    dummy = self.änderungs_feld_rho.get()
    if dummy != "" and dummy != str(self.rho):  
      try:
        if float(dummy) > 0.0:
          self.rho = float(dummy)
          self.rückgabeliste[2] = True
          self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
          print("rho geändert:",  self.rho) 
        else:
          self.rückgabeliste[3] = False
          self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen rho muß > 0.0 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"        
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen rho ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen rho") 
 
    dummy = self.änderungs_feld_s_init.get()
    if dummy != "":  
      try:
        self.s_init = float(dummy)
        self.rückgabeliste[2] = True
        print("s_init geändert:",  self.s_init) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen s_init ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen T_init") 
            
    dummy = self.änderungs_feld_T_init.get()
    if dummy != "" and dummy != str(self.T_init):  
      try:
        self.T_init = float(dummy)
        self.rückgabeliste[2] = True
        self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
        print("T_init geändert:",  self.T_init) 
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen T_init ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
    else:
      print("Keine Änderung der Variablen T_init") 
        
    dummy = self.änderungs_feld_eps.get()
    if dummy != "" and dummy != str(self.eps): 
      try:
        if float(dummy) > 0.0:
          self.eps = float(dummy)
          self.rückgabeliste[2] = True
          self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
          print("epsilon geändert:",  self.eps) 
        else:
          self.rückgabeliste[3] = False
          self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen epsilon muß > 0.0 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"        
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen epsilon ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"  
    else:
      print("Keine Änderung der Variablen epsilon")           
  
    dummy = self.änderungs_feld_max_iter.get()
    if dummy != "" and dummy != str(self.max_iter): 
      try:
        if int(dummy) > 0:
          self.max_iter = int(dummy)
          self.rückgabeliste[2] = True
          self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
          print("max_iter geändert:",  self.max_iter) 
        else:
          self.rückgabeliste[3] = False
          self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen max_iter muß > 0 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"        
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen max_iter ist keine ganze Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"   
    else:
      print("Keine Änderung der Variablen max_iter")
      
    dummy = self.änderungs_feld_resi_max.get()
    if dummy != "" and dummy != str(self.resi_max):   
      try:
        if float(dummy) > 0.0:
          self.resi_max = float(dummy)
          self.rückgabeliste[2] = True
          self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
          print("resi_max geändert:",  self.resi_max) 
        else:
          self.rückgabeliste[3] = False
          self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen resi_max muß > 0.0 sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"        
      except:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen resi_max ist keine Zahl!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!" 
    else:
      print("Keine Änderung der Variablen resi_max")


      
    dummy = self.änderungs_feld_schirm_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.schirm_ausgabe_wähler):  
      self.schirm_ausgabe_wähler = self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("schirm_ausgabe geändert:", self.schirm_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen schirm_ausgabe_wähler")  
      
    dummy = self.änderungs_feld_datei_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.datei_ausgabe_wähler):  
      self.datei_ausgabe_wähler =  self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("datei_ausgabe_wähler geändert:", self.datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen datei_ausgabe_wähler") 
      
    dummy = self.änderungs_feld_ausgabe_datei.get()
    if dummy != "" and dummy != self.ausgabe_datei:
      self.ausgabe_datei = dummy
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("ausgabe_datei geändert:",  self.ausgabe_datei) 
    else:
      print("Keine Änderung der Variablen ausgabe_datei")       
      
    dummy = self.änderungs_feld_index_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.index_ausgabe_wähler):  
      self.index_ausgabe_wähler =  self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("index_ausgabe_wähler geändert:", self.index_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen index_ausgabe_wähler")    
                                   

    dummy = self.änderungs_feld_ausgabe_ascii_bin.get()
    if dummy != "" and dummy != self.ausgabe_ascii_bin:  
      if dummy == "a" or dummy == "b":
        self.ausgabe_ascii_bin = dummy
        self.rückgabeliste[2] = True
        self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
        print("self.ausgabe_ascii_bin geändert:", self.ausgabe_ascii_bin) 
      else:
        self.rückgabeliste[3] = False
        self.rückgabeliste[4] = "Fehler in Eingabe: Wert der Variablen ausgabe_ascii_bin muß a oder b sein.\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"            
    else:
      print("Keine Änderung der Variablen")  
                                    
    dummy = self.änderungs_feld_graphik_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.graphik_ausgabe_wähler):  
      self.graphik_ausgabe_wähler = self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("graphik_ausgabe_wähler geändert:", self.graphik_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen") 
      
    dummy = self.änderungs_feld_graphik_datei_ausgabe_wähler.get()
    if dummy != "" and dummy != str(self.graphik_datei_ausgabe_wähler):  
      self.graphik_datei_ausgabe_wähler = self.bool_function(dummy)
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("graphik_datei_ausgabe_wähler geändert:", self.graphik_datei_ausgabe_wähler) 
    else:
      print("Keine Änderung der Variablen graphik_ausgabe_wähler") 
          
          
    dummy = self.änderungs_feld_graphik_3d_datei_name.get()
    if dummy != "" and dummy != self.graphik_3d_datei_name:  
      self.graphik_3d_datei_name = dummy
      self.rückgabeliste[2] = True#
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten."
      print("graphik_3d_datei_name geändert:",  self.graphik_3d_datei_name) 
    else:
      print("Keine Änderung der Variablen graphik_3d_datei_name")       

    dummy = self.änderungs_feld_graphik_3d_datei_format.get()
    if dummy != "" and dummy != self.graphik_datei_format: 
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten."  
      if dummy in self.graphik_formate_zulässig:
        self.graphik_3d_datei_format = dummy
      else:
        self.rückgabeliste[3] = False 
        self.rückgabeliste[4] = "Fehler in Eingabe: Python unterstützt das Graphikformat nicht!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      print("graphik_3d_datei_format geändert:",  self.graphik_3d_datei_format) 
    else:
      print("Keine Änderung der Variablen graphik_datei_format") 
 
 
    dummy = self.änderungs_feld_graphik_kontur_datei_name.get()
    if dummy != "" and dummy != self.graphik_kontur_datei_name:  
      self.graphik_kontur_datei_name = dummy
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten."      
      print("graphik_kontur_datei_name geändert:",  self.graphik_kontur_datei_name) 
    else:
      print("Keine Änderung der Variablen graphik_3d_datei_name")       

    dummy = self.änderungs_feld_graphik_kontur_datei_format.get()
    if dummy != "" and dummy != self.graphik_kontur_datei_format: 
      self.rückgabeliste[2] = True  
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten."
      if dummy in self.graphik_formate_zulässig:
        self.graphik_kontur_datei_format = dummy
      else:
        self.rückgabeliste[3] = False 
        self.rückgabeliste[4] = "Fehler in Eingabe: Python unterstützt das Graphikformat nicht!\nProgramm rechnet mit dem Wert aus der Steuerdatei weiter!"
      print("graphik_kontur_datei_format geändert:",  self.graphik_kontur_datei_format) 
    else:
      print("Keine Änderung der Variablen graphik_datei_format")  
 
      
    dummy = self.änderungs_feld_graphik_titel.get()
    if dummy != "" and dummy != self.graphik_titel:  
      self.graphik_titel = dummy
      self.rückgabeliste[2] = True
      self.rückgabeliste[4] = "Manuelle Änderung von Steuerdaten." 
      print("graphik_titel geändert :",  self.graphik_titel) 
    else:
      print("Keine Änderung der Variablengraphik_titel")    

#*************************************************************
# Abspeichern der veränderten Eingabedaten in eine neue Steuerdatei
#*************************************************************
    
    fobj_out = open("steuer_neu.txt","w")   
    fobj_out.write("Name der Gitterdatei:\n")
    fobj_out.write(self.gitter_datei)
    fobj_out.write("\n")
    fobj_out.write("Gitter ASCII oder binär:\n")
    fobj_out.write(self.gitter_ascii_bin) 
    fobj_out.write("\n")
    fobj_out.write("Rand_bed_datei:\n")
    fobj_out.write(self.rand_datei)
    fobj_out.write("\n")
    fobj_out.write("lambda:\n")
    fobj_out.write(str("%8.6f" %self.lambada))
    fobj_out.write("\n")
    fobj_out.write("c:\n")
    fobj_out.write(str("%8.6f" %self.c))
    fobj_out.write("\n")
    fobj_out.write("rho:\n")
    fobj_out.write(str("%8.6f" %self.rho))
    fobj_out.write("\n")
    fobj_out.write("s_init:\n")
    fobj_out.write(str("%8.6f" %self.s_init))    
    fobj_out.write("\n")    
    fobj_out.write("T_init:\n")
    fobj_out.write(str("%8.6f" %self.T_init))
    fobj_out.write("\n")
    fobj_out.write("epsilon:\n")
    fobj_out.write(str("%18.16f" %self.eps))
    fobj_out.write("\n")
    fobj_out.write("max_iter:\n")
    fobj_out.write(str("%8i" %self.max_iter))
    fobj_out.write("\n")
    fobj_out.write("omega:\n")
    fobj_out.write(str("%8.6f" %self.omega))
    fobj_out.write("\n")
    fobj_out.write("resi_max:\n")
    fobj_out.write(str("%.3e" % (self.resi_max)))
    fobj_out.write("\n")  
    fobj_out.write("Bildschirmausgabe?:\n")
    fobj_out.write(str(self.schirm_ausgabe_wähler)) 
    fobj_out.write("\n")     
    fobj_out.write("Dateiausgabe?:\n")
    fobj_out.write(str(self.datei_ausgabe_wähler)) 
    fobj_out.write("\n")
    fobj_out.write("Ausgabedatei:\n")
    fobj_out.write(self.ausgabe_datei)
    fobj_out.write("\n")     
    fobj_out.write("Indexausgabe?:\n")
    fobj_out.write(str(self.index_ausgabe_wähler)) 
    fobj_out.write("\n")   
    fobj_out.write("Ausgabedatei ASCII oder binär?:\n")
    fobj_out.write(str(self.ausgabe_ascii_bin)) 
    fobj_out.write("\n")      
    fobj_out.write("Graphikausgabe?:\n")
    fobj_out.write(str(self.graphik_ausgabe_wähler)) 
    fobj_out.write("\n")   
    fobj_out.write("Graphikdateiausgabe?:\n")
    fobj_out.write(str(self.graphik_datei_ausgabe_wähler)) 
    fobj_out.write("\n")     
    fobj_out.write("Name der 3d_Graphikdatei:\n")
    fobj_out.write(self.graphik_3d_datei_name)
    fobj_out.write("\n") 
    fobj_out.write("Format der 3d_Graphikdatei:\n")
    fobj_out.write(self.graphik_3d_datei_format)
    fobj_out.write("\n")   
    fobj_out.write("Name der kontur_Graphikdatei:\n")
    fobj_out.write(self.graphik_kontur_datei_name)
    fobj_out.write("\n") 
    fobj_out.write("Format der kontur_Graphikdatei:\n")
    fobj_out.write(self.graphik_kontur_datei_format)
    fobj_out.write("\n")    
    fobj_out.write("Graphiktitel:\n")
    fobj_out.write(self.graphik_titel)
    fobj_out.write("\n")                      
    fobj_out.close   
                              
#*************************************************************
# Anzeigen der Steuerdaten mittels Label und Grid
# sowie der Möglichkeit, andere Eingabedaten einzugeben
#*************************************************************    
  def eingabe_neu(self):
    try:
      import tkinter
      self.eingabe_gui_neu = tkinter.Tk() 
      for i in range(self.zeilen_zähler):            
        lb = tkinter.Label(self.eingabe_gui_neu, text = self.anzeige_liste[i])
        if i % 2 == 0:
          lb.grid(row=int(i/2), column=0, padx='1', pady='1', sticky='ew')
        else:
          lb.grid(row=int((i-1)/2), column=1, padx='1', pady='1', sticky='ew')
        
        lb["font"] = "Arial 10"
        lb["bg"] = "#FFFFFF"
        lb["fg"] = "#000000"
        if i % 2 == 0:
          lb["anchor"] = "w"
        else:
          lb["anchor"] = "e"


      # Radio-Button-Variablen
      self.gitter_ascii_bin_zwischen = tkinter.StringVar()
      self.gitter_ascii_bin_zwischen.set(self.gitter_ascii_bin)   
      self.ausgabe_ascii_bin_zwischen = tkinter.StringVar()
      self.ausgabe_ascii_bin_zwischen.set(self.ausgabe_ascii_bin)
      self.schirm_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.schirm_ausgabe_wähler_zwischen.set(str(self.schirm_ausgabe_wähler))
      self.datei_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.datei_ausgabe_wähler_zwischen.set(str(self.datei_ausgabe_wähler))
      self.index_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.index_ausgabe_wähler_zwischen.set(str(self.index_ausgabe_wähler))      
      self.graphik_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_ausgabe_wähler_zwischen.set(str(self.graphik_ausgabe_wähler))  
      self.graphik_datei_ausgabe_wähler_zwischen = tkinter.StringVar()
      self.graphik_datei_ausgabe_wähler_zwischen.set(str(self.graphik_datei_ausgabe_wähler)) 

      
      self.änderungs_feld_gitter_datei = tkinter.Entry(self.eingabe_gui_neu)
#      self.änderungs_feld_gitter_ascii_bin = tkinter.Entry(self.eingabe_gui_neu)
# Radio_button     
      self.änderungs_feld_gitter_ascii_bin_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="ASCII",variable=self.gitter_ascii_bin_zwischen, value = "a")
      self.änderungs_feld_gitter_ascii_bin_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="binär",variable=self.gitter_ascii_bin_zwischen, value = "b")  
            
      self.änderungs_feld_rand_datei = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_lambada = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_c = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_rho = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_s_init = tkinter.Entry(self.eingabe_gui_neu)       
      self.änderungs_feld_T_init = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_eps = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_max_iter = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_omega = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_resi_max  = tkinter.Entry(self.eingabe_gui_neu)
      
#      self.änderungs_feld_schirm_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
# Radio_button     
      self.änderungs_feld_schirm_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.schirm_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_schirm_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.schirm_ausgabe_wähler_zwischen, value = "False")  
      self.änderungs_feld_datei_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.datei_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_datei_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.datei_ausgabe_wähler_zwischen, value = "False")
      
#      self.änderungs_feld_datei_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
      
      self.änderungs_feld_ausgabe_datei = tkinter.Entry(self.eingabe_gui_neu)           
#      self.änderungs_feld_index_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
# Radio_button   
      self.änderungs_feld_index_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.index_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_index_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.index_ausgabe_wähler_zwischen, value = "False") 
      
#      self.änderungs_feld_ausgabe_ascii_bin = tkinter.Entry(self.eingabe_gui_neu)  
# Radio_button  
      self.änderungs_feld_ausgabe_ascii_bin_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="ASCII",variable=self.ausgabe_ascii_bin_zwischen, value = "a")
      self.änderungs_feld_ausgabe_ascii_bin_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="binär",variable=self.ausgabe_ascii_bin_zwischen, value = "b")  
                      
#      self.änderungs_feld_graphik_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
# Radio_button 
      self.änderungs_feld_graphik_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.graphik_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_graphik_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.graphik_ausgabe_wähler_zwischen, value = "False")
      
#      self.änderungs_feld_graphik_datei_ausgabe_wähler = tkinter.Entry(self.eingabe_gui_neu)
# Radio_button 
      self.änderungs_feld_graphik_datei_ausgabe_wähler_1 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Ja",variable=self.graphik_datei_ausgabe_wähler_zwischen, value = "True")
      self.änderungs_feld_graphik_datei_ausgabe_wähler_2 = tkinter.Radiobutton(self.eingabe_gui_neu, text="Nein",variable=self.graphik_datei_ausgabe_wähler_zwischen, value = "False")      
      self.änderungs_feld_graphik_3d_datei_name = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_3d_datei_format = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_kontur_datei_name = tkinter.Entry(self.eingabe_gui_neu)
      self.änderungs_feld_graphik_kontur_datei_format = tkinter.Entry(self.eingabe_gui_neu)      
      self.änderungs_feld_graphik_titel = tkinter.Entry(self.eingabe_gui_neu) 
      self.änderungs_feld_gitter_datei.grid(row=0, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')    
#      self.änderungs_feld_gitter_ascii_bin.grid(row=1, column=2, padx='1', pady='1', sticky='ew') 
# Radio_button          
      self.änderungs_feld_gitter_ascii_bin_1.grid(row=1, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_gitter_ascii_bin_2.grid(row=1, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_gitter_ascii_bin = self.gitter_ascii_bin_zwischen      
      self.änderungs_feld_rand_datei.grid(row=2, column=2, columnspan = 2,padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_lambada.grid(row=3, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_c.grid(row=4, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_rho.grid(row=5, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_s_init.grid(row=6, column=2,columnspan = 2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_T_init.grid(row=7, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')  
      self.änderungs_feld_eps.grid(row=8, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_max_iter.grid(row=9, column=2, columnspan = 2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_omega.grid(row=10, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_resi_max.grid(row=11, column=2, columnspan = 2,padx='1', pady='1', sticky='ew') 
      
#      self.änderungs_feld_schirm_ausgabe_wähler.grid(row=11, column=2, padx='1', pady='1', sticky='ew')
# Radio_button
      self.änderungs_feld_schirm_ausgabe_wähler_1.grid(row=12, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_schirm_ausgabe_wähler_2.grid(row=12, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_schirm_ausgabe_wähler = self.schirm_ausgabe_wähler_zwischen 
      
#      self.änderungs_feld_datei_ausgabe_wähler.grid(row=12, column=2, padx='1', pady='1', sticky='ew')  
# Radio_button
      self.änderungs_feld_datei_ausgabe_wähler_1.grid(row=13, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler_2.grid(row=13, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_datei_ausgabe_wähler = self.datei_ausgabe_wähler_zwischen 
      self.änderungs_feld_ausgabe_datei.grid(row=14, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')      
#      self.änderungs_feld_index_ausgabe_wähler.grid(row=14, column=2, padx='1', pady='1', sticky='ew') 
# Radio_button
      self.änderungs_feld_index_ausgabe_wähler_1.grid(row=15, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_index_ausgabe_wähler_2.grid(row=15, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_index_ausgabe_wähler = self.index_ausgabe_wähler_zwischen
      
#      self.änderungs_feld_ausgabe_ascii_bin.grid(row=15, column=2, padx='1', pady='1', sticky='ew') 
# Radio_button          
      self.änderungs_feld_ausgabe_ascii_bin_1.grid(row=16, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_ausgabe_ascii_bin_2.grid(row=16, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_ausgabe_ascii_bin = self.ausgabe_ascii_bin_zwischen   
                      
#      self.änderungs_feld_graphik_ausgabe_wähler.grid(row=16, column=2, padx='1', pady='1', sticky='ew')
# Radio_button
      self.änderungs_feld_graphik_ausgabe_wähler_1.grid(row=17, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_ausgabe_wähler_2.grid(row=17, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_ausgabe_wähler = self.graphik_ausgabe_wähler_zwischen      
      
#      self.änderungs_feld_graphik_datei_ausgabe_wähler.grid(row=17, column=2, padx='1', pady='1', sticky='ew')
# Radio_button
      self.änderungs_feld_graphik_datei_ausgabe_wähler_1.grid(row=18, column=2, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_ausgabe_wähler_2.grid(row=18, column=3, padx='1', pady='1', sticky='ew') 
      self.änderungs_feld_graphik_datei_ausgabe_wähler = self.graphik_datei_ausgabe_wähler_zwischen        
      
      self.änderungs_feld_graphik_3d_datei_name.grid(row=19, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')     
      self.änderungs_feld_graphik_3d_datei_format.grid(row=20, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
      self.änderungs_feld_graphik_kontur_datei_name.grid(row=21, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')     
      self.änderungs_feld_graphik_kontur_datei_format.grid(row=22, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')      
      self.änderungs_feld_graphik_titel.grid(row=23, column=2, columnspan = 2, padx='1', pady='1', sticky='ew')
#*************************************************************
# Button zum Beenden der Anzeige der Steuerdaten
# Button zur Übernahme der geänderten Eingabedaten
# zum Start der Berechnungen
#*************************************************************      
      weiter_button = tkinter.Button(self.eingabe_gui_neu, text = "weiter", command = self.ende_neu)
      weiter_button.grid(row=24, column=0, padx='1', pady='1', sticky='ew')
      übernahme_button = tkinter.Button(self.eingabe_gui_neu, text = "übernehmen", command = self.übernahme)
      übernahme_button.grid(row=24, column=2, padx='1', pady='1', sticky='ew')
      
      #Endlosschleife
      self.eingabe_gui_neu.mainloop()
           
      print("Einlesen o.k.")
      self.rückgabewert = True
  
    except:
      print("Fehler beim Dateieinlesen")
      self.rückgabewert = False
    return self.rückgabewert   

      
  def bool_function(self,arg):
    s_true = set(["True", "true", "T", "t", "1" ])
    s_false = set(["False", "false", "F", "f", "0" ])
    if arg in s_true:
      return True
    elif arg in s_false:
      return False
    else:     
      return True

